SystemOrganization addCategory: #'Seaside-Pharo-Tools-Spec'!

!GRPackage class methodsFor: '*seaside-pharo-tools-spec' stamp: 'pmm 9/16/2013 10:37'!
seasidePharoToolsSpec
	^ self new
		name: 'Seaside-Pharo-Tools-Spec';
		description: 'Spec based server adapter browser for Pharo';
		addDependency: 'Seaside-Tools-Core';
		url: #seasideUrl;
		yourself! !

Object subclass: #WAPharoToolsIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons Instance'
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAPharoToolsIcons class methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 17:46'!
default
	^ Instance ifNil: [ Instance := self new ]! !

!WAPharoToolsIcons class methodsFor: 'private' stamp: 'StephanEggermont 8/31/2012 17:46'!
findIcon: aSymbol
	(self canUnderstand: aSymbol)
		ifTrue: [ ^ self default perform: aSymbol ].
	^ UITheme current
		iconNamed: ('small' , aSymbol capitalized) asSymbol
		ifNone: [ UITheme current iconNamed: aSymbol ]! !

!WAPharoToolsIcons class methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 17:46'!
iconNamed: aSymbol
	^ Icons at: aSymbol ifAbsentPut: [ self findIcon: aSymbol ]! !

!WAPharoToolsIcons class methodsFor: 'initialization' stamp: 'StephanEggermont 8/31/2012 17:46'!
initialize
	Instance := nil.
	Icons := IdentityDictionary new! !

ComposableModel subclass: #WAPharoServerAdapterSpecBrowser
	instanceVariableNames: 'listModel textModel toolbarModel adaptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAPharoServerAdapterSpecBrowser commentStamp: '<historical>' prior: 0!
WAPharoServerAdapterSpecBrowser example!

!WAPharoServerAdapterSpecBrowser class methodsFor: 'specs' stamp: 'JohanBrichau 2/7/2014 09:47'!
defaultSpec
	<spec>
	| delta |
	delta := 15.
	^ SpecLayout composed 
			add: #listModel origin: 0@0 corner: 1@0.5 offsetOrigin: 0@0 offsetCorner: 0@(delta negated);
			add: #toolbarModel origin: 0@0.5 corner: 1@0.5 offsetOrigin: 0@(delta negated) offsetCorner: 0@delta;
			add: #textModel origin: 0@0.5 corner: 1@1 offsetOrigin: 0@delta offsetCorner: 0@0;
			yourself! !

!WAPharoServerAdapterSpecBrowser class methodsFor: 'example' stamp: 'pmm 9/13/2013 15:23'!
open
	"self open"
	WAPharoServerAdapterSpecBrowser new openWithSpec
! !

!WAPharoServerAdapterSpecBrowser class methodsFor: 'specs' stamp: 'StephanEggermont 8/31/2012 14:50'!
title
	^'Seaside Control Panel'! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:50'!
adapters: aList
	self listModel items: aList! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'pmm 9/13/2013 15:11'!
adaptor
	^ adaptor! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'pmm 9/13/2013 15:03'!
disableAllButtons

	self toolbarModel startButton enabled: false.
	self toolbarModel stopButton enabled: false.
	self toolbarModel browseButton enabled: false! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 9/13/2013 14:49'!
enableBrowseButton

	self toolbarModel browseButton enabled: true! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 9/13/2013 14:49'!
enableStartButton

	self toolbarModel startButton enabled: true! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 9/13/2013 14:49'!
enableStopButton

	self toolbarModel stopButton enabled: true! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'initialization' stamp: 'pmm 9/13/2013 15:22'!
initializePresenter

	self adapters: WAServerManager default adaptors.
	
	listModel whenSelectedItemChanged: [ :selection |
		adaptor := selection.
		self disableAllButtons.
		selection isNil
			ifTrue: [
				textModel text: ''.
				textModel behavior: nil ]
	             ifFalse: [ 
				adaptor isStopped
					ifTrue: [ self enableStartButton ].
				adaptor isRunning
					ifTrue: [ self enableStopButton	 ].
				self enableBrowseButton.
				textModel text: (String streamContents: [ :stream |
			stream 
				nextPutAll: 'Type: '; nextPutAll: adaptor class name; nextPut: Character cr;
				nextPutAll: 'Port: '; nextPutAll: adaptor port greaseString; nextPut: Character cr;
				nextPutAll: 'Encoding: '; nextPutAll: adaptor codec name; nextPut: Character cr.
			adaptor additionalStatusOn: stream.
			stream
				nextPutAll: adaptor statusString ]) ]]
! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'initialization' stamp: 'pmm 9/13/2013 15:20'!
initializeWidgets

	self instantiateModels: #(
		listModel IconListModel
		textModel TextModel
		toolbarModel WAServerAdapterToolbar).
	
	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel.
	
	textModel aboutToStyle: false.
	listModel displayBlock: [ :item | item name].
	self disableAllButtons! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'pmm 9/13/2013 15:19'!
listModel
	^ listModel! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'pmm 9/13/2013 15:20'!
textModel
	^ textModel! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'pmm 9/13/2013 15:20'!
toolbarModel
	^ toolbarModel! !

ComposableModel subclass: #WAServerAdapterToolbar
	instanceVariableNames: 'startButton stopButton browseButton startAction stopAction browseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAServerAdapterToolbar class methodsFor: 'specs' stamp: 'JohanBrichau 2/7/2014 09:53'!
defaultSpec

	<spec>
	^ SpecLayout composed
		newRow: [ :row | 
			row
				add: #(model startButton);
				add: #(model stopButton);
				add: #(model browseButton) ];
		yourself! !

!WAServerAdapterToolbar class methodsFor: 'specs' stamp: 'StephanEggermont 8/31/2012 16:20'!
title
	^'Server adapter toolbar'! !

!WAServerAdapterToolbar methodsFor: 'actions' stamp: 'pmm 9/13/2013 15:17'!
browseAdaptor

	self owner adaptor ifNotNilDo: [ :adaptor |
		adaptor inspect ]! !

!WAServerAdapterToolbar methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 16:26'!
browseButton
	^browseButton! !

!WAServerAdapterToolbar methodsFor: 'initialization' stamp: 'StephanEggermont 8/31/2012 16:12'!
initialize
	super initialize.
	startAction := [true] asValueHolder.
	stopAction := [true] asValueHolder.
	browseAction := [true] asValueHolder.! !

!WAServerAdapterToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 9/13/2013 14:50'!
initializeWidgets

	self instantiateModels: #(
		startButton ButtonModel
		stopButton ButtonModel
		browseButton ButtonModel).
	
	self registerStartButtonEvents.
	self registerStopButtonEvents.
	self registerBrowseButtonEvents.
	
	self focusOrder 
		add: startButton;
		add: stopButton;
		add: browseButton.
	! !

!WAServerAdapterToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:51'!
registerBrowseButtonEvents

	browseButton 
		label: 'Browse';
		enabled: true;
		action: [ self browseAdaptor ];
		state: false! !

!WAServerAdapterToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:51'!
registerStartButtonEvents

	startButton 
		label: 'Start';
		enabled: true;
		action: [ self startAdaptor ];
		state: false! !

!WAServerAdapterToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:51'!
registerStopButtonEvents

	stopButton 
		label: 'Stop';
		enabled: true;
		action: [ self stopAdaptor ];
		state: false! !

!WAServerAdapterToolbar methodsFor: 'actions' stamp: 'pmm 9/13/2013 15:12'!
startAdaptor

	self owner adaptor ifNotNilDo: [ :adaptor |
		adaptor start ]! !

!WAServerAdapterToolbar methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 16:26'!
startButton
	^startButton! !

!WAServerAdapterToolbar methodsFor: 'actions' stamp: 'pmm 9/13/2013 15:12'!
stopAdaptor

	self owner adaptor ifNotNilDo: [ :adaptor |
		adaptor stop ]! !

!WAServerAdapterToolbar methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 16:26'!
stopButton
	^stopButton! !
WAPharoToolsIcons initialize!
